
; using 2-bit bit-vectors as characters

(set-logic QF_BVRE)
(define-sort CHAR () (_ BitVec 2))
(define-sort S () (Seq CHAR))
(define-sort R () (RegEx CHAR))

(declare-fun p0 (S) Bool)
(declare-fun p1 (S) Bool)

(define-fun a () CHAR #b00)
(define-fun b () CHAR #b11)

(define-fun anything () R
            (re-star (re-union (re-of-seq (seq-unit a))
                               (re-of-seq (seq-unit b)))))
(define-fun badRegex () R
            (re-concat (re-concat
               anything
               (re-of-seq (seq-cons b (seq-unit a))))
               anything
             ))

(assert (p0 (as seq-empty S)))
(assert (forall ((s S))
          (=> (p0 s)
              (p0 (seq-cons a (seq-concat s (seq-unit b)))))))

(assert (forall ((s S)) (=> (p0 s) (p1 s))))

(assert (forall ((s S)) (not (and (p1 s) (re-member s badRegex)))))
(assert (forall ((s S)) (=> (p1 s) (= (mod (seq-length s) 2) 0))))

(check-sat)
